#
# spec file for package joycond
#
# Copyright (c) 2022 SUSE LLC
# Copyright (c) 2021/22 Florian "sp1rit" <packaging@sp1rit.anonaddy.me>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%if %{undefined _modulesloaddir}
%define _modulesloaddir %{_prefix}/lib/modules-load.d/
%endif

Name:           joycond
Version:        0.1.0+git.51~f9a6691
Release:        3.10
Summary:        Userspace daemon for using joy-cons with the hid-nintendo kernel driver
Group:          Hardware/Joystick
License:        GPL-3.0-or-later
URL:            https://github.com/DanielOgorchock/joycond
Source0:        %{name}-%{version}.tar.xz
BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  systemd-rpm-macros
BuildRequires:  pkgconfig(libevdev)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(systemd)
Enhances:       kmod(hid_nintendo.ko)
Requires:       kmod(hid_nintendo.ko)
Recommends:     %{name}-autoload

%package        autoload
Summary:        Configuration for autoloading extra joycond modules
BuildArch:      noarch
Requires:       %{name}

%description
joycond is a Linux daemon which uses evdev devices provided by
hid-nintendo (formerly known as hid-joycon) to implement joycond
pairing.

%description autoload
Configuration files to autoload optional kernel modules during
system startup. These provide the joycond the possibility of
signaling controller status by flashing its LEDs.

%prep
%autosetup -p1

%build
%cmake
%cmake_build

%install
%cmake_install
mkdir -p %{buildroot}%{_sbindir}/
mkdir -p %{buildroot}%{_modulesloaddir}/
mkdir -p %{buildroot}%{_unitdir}/
mkdir -p %{buildroot}%{_udevrulesdir}/
ln -s /usr/sbin/service %{buildroot}%{_sbindir}/rcjoycond
mv %{buildroot}/etc/modules-load.d/%{name}.conf %{buildroot}%{_modulesloaddir}/%{name}.conf
mv %{buildroot}/etc/systemd/system/%{name}.service %{buildroot}%{_unitdir}/%{name}.service
mv %{buildroot}/lib/udev/rules.d/{72,89}-joycond.rules %{buildroot}%{_udevrulesdir}/

%pre
%service_add_pre %{name}.service

%post
%service_add_post %{name}.service

%preun
%service_del_preun %{name}.service

%postun
%service_del_postun %{name}.service

%files
%license LICENSE
%doc README.md
%{_unitdir}/%{name}.service
%{_sbindir}/rcjoycond
%{_udevrulesdir}/72-%{name}.rules
%{_udevrulesdir}/89-%{name}.rules
%{_bindir}/%{name}

%files autoload
%dir %{_modulesloaddir}
%{_modulesloaddir}/%{name}.conf

%changelog
* Mon Apr 25 2022 Florian "sp1rit" <sp1ritCS@protonmail.com>
- Ensured joycond-autoload owns /usr/lib/modules-load.d/ to prevent
  build failure on Tumbleweed.
* Sat Jan 15 2022 Florian "spirit" <packaging@sp1rit.anonaddy.me>
- Lessened reverse dependency of kmod(hid_nintendo), as otherwise
  joycond will be installed on any machine that runs Linux >= 5.16.
* Sat Jan 15 2022 Florian "spirit" <packaging@sp1rit.anonaddy.me>
- Clarified license: changed GPL-3.0 to GPL-3.0-or-later
* Fri Jan 14 2022 Jan Engelhardt <jengelh@inai.de>
- Package descriptions are not supposed to be manuals: Strip
  instructions from package descriptions.
- Use noun phrase for summaries/descriptions.
* Fri Jan 14 2022 Florian "spirit" <packaging@sp1rit.anonaddy.me>
- Amended issues @dimstar requested
  * dropped systemd install-time dependency
  * joycond-autoload now depends on joycond
* Fri Jan 14 2022 Florian "spirit" <packaging@sp1rit.anonaddy.me>
- Removed buildtime service runs
- Restructured install-time dependencies
* Fri Jan 14 2022 Florian "sp1rit" <packaging@sp1rit.anonaddy.me>
- Update to version 0.1.0+git.51~f9a6691:
  * Add Fedora install instructions
  * include virt pro controller in android builds
  * added man page
  * support updated hid-nintendo led names
  * udev: finally actually remove uaccess from procon
  * udev: prevent steam from using pro controller hidraw
  * update readme to include new virtual procon support
  * add support for virtual uinput pro controllers
  * Remap digital DPAD buttons to HAT inputs for Android
  * Add SNES controller support.
* Fri Aug 13 2021 Florian "sp1rit" <sp1ritCS@protonmail.com>
- Initial packaging
